/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.9a Evaluation
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 16.11.2010
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type               : ATtiny2313
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
*****************************************************/

#include <stdio.h>
#include <TINY4313_BITS.h> 
#include <tiny2313.h>    //   /
#include <delay.h>        //    

#define digit1 PORTD.6      //   - 
#define digit2 PORTD.5      //   - 
#define digit3 PORTA.0      //  
#define buzer  PORTD.4          //
#define out0volt PORTD.3        //   
#define rele_napravlen PORTD.1  //    
                   
flash char digits[] = {      //   
0x60,                   //0
0xF9,                   //1
0xA4,                   //2
0xB0,                   //3
0x39,                   //4
0x32,                   //5
0x22,                   //6
0xF8,                   //7
0x20,                   //8
0x30,                   //9
0b11111101,                   // 
0b11111111                    //
};                 

char digit_out[3], cur_dig;   //    LED
unsigned int indication;     //     LED 
unsigned char tmp=0;        //     1
bit flag0=0;               //      0
                          //  122   
bit flag1=0;             //      1
unsigned char x=0;      // 
unsigned char time=0;   //   
unsigned char y=0;      // 
unsigned int z=0;      // 
unsigned int N=0;      // 
bit x5=0;               // 
//*****************************************************
void wait(void)
{
x=flag0;    
y=0;
z=N;
//m1:
if (y<z)                 // y<z
    {   if (x==~flag0)   //  
        {y=y+1;x=flag0;}  // y,     
        else    {};
    };
}

void stop(void)
{
TCCR1B=0x00;    //  1
time=30;        //     1
out0volt=0;     //  
buzer=0;        // 
N=61;            //     0,5
wait();       // 
buzer=1;        // 
}

void recoding(void)            //    hex  dec
{ if (indication<1000)           //    < 1000  
    {                            //3- LED
    digit_out[0]=indication%10;   //  10    1-
    indication=indication/10;     // 2 
    digit_out[1]=indication%10;   //  10    2-
    digit_out[2]=indication/10;     //  10     3-
    }                                         
}                                 
//******************************************************

void counter(void)
{
if (tmp>=2)        //    240(  2  240)
   {time=tmp/2;   //   1  (  2  240)
    x5=time/5;       //   5 
    if (time==30)    //   30
    {stop();}        //  - 
    else                    //    30
        {if (x5==1) {buzer=0;x5=0;
        N=5000;wait();buzer=1;} // -   5    
         else  {};                  //  5
        };

   }
else  
   {    
   };
}


//******************************************************
void start(void)  // - start
{
indication=0;   //    
TCCR1B=0x00;    //  1
TCCR1B=0x0D;    // 1  7813       
}
//******************************************************
// External Interrupt 0 service routine
//interrupt [EXT_INT0] void ext_int0_isr(void)
//{
//start(); // 0      
//}
//******************************************************
// 0
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
flag0=~flag0;   //   0
PORTB=0xFF;       //      
    switch (cur_dig){
    case 0:{digit3=1; digit1=0; break;};  //    3
    case 1:{digit1=1; digit2=0; break;};  //    2
    case 2:{digit2=1; digit3=0; break;};  //    1
                }                         //  digit->0, OK->1
PORTB=digits[digit_out[cur_dig]];  //      
                                   //a   ,      

cur_dig++;                          //   , 
                                    // cur_dig  1
if(cur_dig==3) cur_dig=0;           // cur_dig = 3 
}


// Timer1 output compare A interrupt service routine
//  0,2.
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
    tmp=tmp+1;
    flag1=~flag1;   //   
//    buzer=flag1;    //       
    counter();
    indication=time; //   
    recoding();     //   

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=Out Func0=In 
// State6=1 State5=1 State4=1 State3=1 State2=T State1=1 State0=P 
PORTD=0x7B;
DDRD=0x7A;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x04;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x08;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x06;    //  200
OCR1AL=0x59;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Low level
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x40;
MCUCR=0x00;
EIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x42;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Global enable interrupts
#asm("sei")

//indication=0;   //    
//TCCR1B=0x00;    //  1
//TCCR1B=0x0D;    // 1  7813    

  start();
//while (1)
//      {}
}
